//	ATtiny2313
//	7ZO4{[hp
//	
//	v	\18:88LEDp
//	E12Ԑ
//	EJ_[
//	E

/*
|[gΉ	[ATtiny2313]	x:݂Ȃ(PA2RESET) -:
bit		7	6	5	4	3	2	1	0
portA	x	x	x	x	x	x	-	clk
portB	swL	swR	-	DP	4	3	2	1		LED{[hł͍猅1-4(LED1-LED4)
portD	x	G	F	E	D	C	B	A		7ZÕZOgi}j

7ZÕZOg}
+-A-+
F   B
+-G-+
E   C
+-D-+ DP

q[Yrbg
Low: 01100000
     ||||++++-- CKSEL[3:0] VXeNbNI
     ||++-- SUT[1:0] N
     |+-- CKOUT (0:PD2ɃVXeNbNo)
     +-- CKDIV8 NbNl (1:1/1, 0:1/8)

rh
WinAVR-20080610		œKIvV:-Os
ATtiny2313	11.776MHz/8(1.472MHz)	ɃvOCLKPRɂĕύX


2010/01/31	v1.00	Program:    1900 bytes (92.8% Full)
				ESSeg4Clock ver1.00x[Xɉ
*/


//--------------------------------------------------
//	7ZÕ^Cv	1:J\[hR 0:Am[hR
#define	_CATHODE_CMN_	1
//--------------------------------------------------

#include	<avr/io.h>
#include	<avr/interrupt.h>
#include	<avr/eeprom.h>
#include	<avr/pgmspace.h>


//7ZÕp^[`
const	prog_uint8_t	SEGCHAR[]	=
{
//	0b0GFEDCBA
	0b00111111,		//0
	0b00000110,		//1
	0b01011011,		//2
	0b01001111,		//3
	0b01100110,		//4
	0b01101101,		//5
	0b01111101,		//6
	0b00100111,		//7
	0b01111111,		//8
	0b01101111,		//9
	0b00000000,		//null
	0b01110110,		//H
//Mon Tue Wed Thu Fri Sat Sun
//	0b0GFEDCBA
	0b00110111,		//Mi'U'̋tŁj
	0b01011100,		//o
	0b01010100,		//n
	0b00110001,		//Ti'u'̌`Łj
	0b00011100,		//u
	0b01111011,		//e
	0b01111110,		//Wi'A'̋tŁj
	0b01011110,		//d
	0b01110100,		//h
	0b01110001,		//F
	0b01010000,		//r
	0b00010000,		//i
	0b01101101,		//Si'5'Ɠ\Ȃj
	0b01011111,		//a
	0b01111000,		//t
//18:88LED
//	0b0GFEDCBA
	0b00100000,		//AM̃hbg
	0b00010000,		//PM̃hbg
	0b01101110		//Y
};

enum	eSEGIDX
{
	SEGIDX_NULL	= 10,
	SEGIDX_H,
	SEGIDX_M,
	SEGIDX_o,
	SEGIDX_n,
	SEGIDX_T,
	SEGIDX_u,
	SEGIDX_e,
	SEGIDX_W,
	SEGIDX_d,
	SEGIDX_h,
	SEGIDX_F,
	SEGIDX_r,
	SEGIDX_i,
	SEGIDX_S,
	SEGIDX_a,
	SEGIDX_t,
	SEGIDX_AM,
	SEGIDX_PM,
	SEGIDX_Y
};

//j
const	prog_uint8_t	SEGIDX_WEEK[]	=
{
	SEGIDX_S, SEGIDX_u, SEGIDX_n,
	SEGIDX_M, SEGIDX_o, SEGIDX_n,
	SEGIDX_T, SEGIDX_u, SEGIDX_e,
	SEGIDX_W, SEGIDX_e, SEGIDX_d,
	SEGIDX_T, SEGIDX_h, SEGIDX_u,
	SEGIDX_F, SEGIDX_r, SEGIDX_i,
	SEGIDX_S, SEGIDX_a, SEGIDX_t
};

//|[gBɂԂDP̃}XN
#define	SEG_DP	0b00010000

//7ZOLEĎʒuƃ|[gB̑Ή
#define	LED1	0	//1([)	= PB0
#define	LED2	1	//2		= PB1
#define	LED3	2	//3		= PB2
#define	LED4	3	//4(E[)	= PB3

//샂[h
enum	eOPMODE
{
	OP_CLOCK,		//v\
	OP_CALENDAR_Y,	//t\iNj
	OP_CALENDAR_MD,	//t\ij
	OP_CALENDAR_W,	//t\ijj
	OP_ADJ_SEC,		//b
	OP_ADJ_MIN,		//
	OP_ADJ_HOUR,	//
	OP_ADJ_COLON,	//b̕\iRhbgj
	OP_ADJ_YEAR,	//N
	OP_ADJ_MONTH,	//
	OP_ADJ_DAY,		//
	OP_ADJ_WEEK		//j
};

//f[^ۑEEPROM̃AhX
enum	eSAVE
{
	SV_YEAR		= 0x00,
	SV_MONTH,
	SV_DAY,
	SV_WEEK,
	SV_HOUR24
};

//v\̕b̕\
enum	eSECBLINK
{
	SECB_COLON,		//[:_ .Ȃ]	0;00
	SECB_DOT,		//[:_ ._]	0:00,
	SECB_STATIC		//[:_ .Ȃ] 0:00
};

//̍ŏIi邤N͍lȂj
const	prog_uint8_t	LAST_DAY[]	= { 0, 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 };

//J_[\̎Jڎ(sec)
#define	CALENDAR_DISP_WAIT	2

//킹̓_Ń^C~O
#define	IS_BLINK(a)		(((a) & 0x40) == 0x40)

volatile	register	uint8_t	bTC	asm("r2");	//荞ݔʒmtOiWX^R2Ɋtj

//16bit^C}	500(ms)Ƃ̌Ăяo
ISR(TIMER1_COMPA_vect)
{
	bTC = 1;
}

int	main(void)
{
	uint8_t	year, month, day, week;		//2AAAj
	uint8_t	hour24, min, sec, msec;		//AAbA~b
	
	uint8_t	portD;
	uint8_t	opMode;			//샂[h
	uint8_t	segDP;			//7ZOLEDDP̏o	SEG_DP:o͂	0:o͂Ȃ
	uint8_t	segidx[4];		//7ZOLEDɏo͂镶p^[̃CfbNXi[z
	uint8_t	keta;			//7ZOLEĎʒu		LED1,`̒l
	uint8_t	hour;			//Ԑ̌vZp
	uint8_t	dyear;			//^lJ_[\puNvidisplaydj
	uint8_t	isPM;			//12ԐŌߑŐ	0:ߑO	1:ߌ	iAM/PMhbgǂo̔Ɏgj
	uint8_t	sw, psw;		//XCb`ǂݎ
	uint8_t	swR, swL;		//XCb`̏	1:on	0:off
	uint8_t	loopCnt;		//^C~O҂ȂǂɎgJE^	0x00-0xFF
	uint8_t	orgsec;			//J_[[hŎIɏԑJڂ邽߂̋N_b
	uint8_t	bDispYear;		//J_[[h́uNv̕\e	0:\ 1:	2:
	uint8_t	idxAmPm;		//AM/PM̃hbg\		SEGIDX_AM, SEGIDX_PM, SEGIDX_NULL
	uint8_t	secBlink;		//b̕\	SECB_COLON, SECB_DOT, SECB_STATIC
	
	//EEPROM N///j/ ǂݍ
	eeprom_busy_wait();	year = eeprom_read_byte((uint8_t*)SV_YEAR);
	if (100 <= year)	//sȒlꍇ
	{
		year = 0;
		month = 1;
		day = 1;
		week = 0;
		hour24 = 0;
	}
	else	//ÓȒlꍇ
	{
		eeprom_busy_wait();	month	= eeprom_read_byte((uint8_t*)SV_MONTH);
		eeprom_busy_wait();	day		= eeprom_read_byte((uint8_t*)SV_DAY);
		eeprom_busy_wait();	week	= eeprom_read_byte((uint8_t*)SV_WEEK);
		eeprom_busy_wait();	hour24	= eeprom_read_byte((uint8_t*)SV_HOUR24);
	}
	
	opMode = OP_CLOCK;
	segDP = 0;
	keta = LED1;
	hour = hour24;
	min = sec = msec = 0;
	isPM = 0;
	orgsec = 0;
	bDispYear = 1;
	psw = sw = 0;
	loopCnt = 0;
	secBlink = SECB_COLON;
	
	//VXeNbNOuݒiO͂11.776MHzj
	CLKPR	= 0b10000000;	//NbNlύX
	CLKPR	= 0b00000110;	//64	11.776MHz/64=184000Hz(184kHz)
	
	//|[gݒ
	DDRD	= 0b01111111;	//7ZOLEDA-G = PD0-PD6
	DDRB	= 0b00011111;	//7ZOLEĎʒu(LED{[h̍) = PB0-PB3, 7ZOLEDDP = PB4
	PORTB	= 0b11000000;	//XCb`2({[h̉E) PB6-PB7
	
	//16bit^C}	v
	TCCR1A	= 0b00000000;	//CTC
	TCCR1B	= 0b00001010;	//(bit2-0)	010:8	clk(184kHz/8=23000Hz)
	TCCR1C	= 0b00000000;	//OC1AύXȂ
	OCR1A	= 11500 - 1;	//rl:n	23000:1sec=n:500ms	n=11500JEg
	
	//荞ݐݒ
	TIMSK	= 0b01000000;	//16bit^C}:rv荞
	
	ACSR	= 0b10000000;	//AiORp[^֎~id͂}邽߁j
	sei();		//荞݋
	
	while (1)
	{
		//荞ݔiԌo߁j
		if (bTC)
		{
			//킹ɋRAl𒴂\̂ŁAr'=='ł͂Ȃ'<='
			//Emsec,sec͎킹ŃCNgȂ̂Łi0Zbĝ݁je󂯂Ȃ
			//Emin,hour24킹̃CNgŉe󂯂
			//̂Ƃmain()̎킹̏ɂ
			
			if (2 <= ++msec)	//500(ms)Ƃ̌ĂяoȂ̂2JEg1(sec)
			{
				msec = 0;
				if (60 <= ++sec)
				{
					sec = 0;
					if (60 <= ++min)
					{
						min = 0;
						if (24 <= ++hour24)		//펞24ԐŃJEgA\iKŉH
						{
							hour24 = 0;
							if (7 <= ++week) week = 0;
							if (pgm_read_byte(&LAST_DAY[month]) < ++day)
							{
								day = 1;
								if (12 < ++month)
								{
									month = 1;
									if (100 <= ++year) year = 0;	//year͐̉2
								}
							}
							//EEPROM N///j 
							eeprom_busy_wait();	eeprom_write_byte((uint8_t*)SV_YEAR, year);
							eeprom_busy_wait();	eeprom_write_byte((uint8_t*)SV_MONTH, month);
							eeprom_busy_wait();	eeprom_write_byte((uint8_t*)SV_DAY, day);
							eeprom_busy_wait();	eeprom_write_byte((uint8_t*)SV_WEEK, week);
						}
						//EEPROM  
						eeprom_busy_wait();	eeprom_write_byte((uint8_t*)SV_HOUR24, hour24);
					}
				}
			}
			bTC = 0;
		}
		
		loopCnt++;
		
		//XCb`ǂݎ
		swL = swR = 0;
		if ((loopCnt & 0x08) == 0x08)	//`^OłxɃ[vԊu󂯂
		{
			sw = PINB & 0b11000000;
			if (psw != sw)
			{
				swR = ~sw & 0b01000000;
				swL = ~sw & 0b10000000;
				psw = sw;
			}
		}
		
		//nԐ̎\
		//12: 12, 1,..........,12, 1,..,11,12
		//24:  0, 1,..........,12,13,..,23, 0
		hour = hour24;
		if (hour24 == 0) hour = 12;
		if (12 < hour24) hour = hour24 - 12;
		isPM = (12 <= hour24);	//^Ƃ12:00̏uԂɌߑO^ߌ؂ւ悤ɂ
								//12́uߌ12vA12́uߑO12vƂȂ
		idxAmPm = SEGIDX_NULL;
		
		//\eύX
		switch (opMode)
		{
		case OP_CLOCK:
			segidx[LED1] = (hour < 10) ? SEGIDX_NULL : 1;
			segidx[LED2] = hour % 10;
			segidx[LED3] = min / 10;
			segidx[LED4] = min % 10;
			switch (secBlink)
			{
			case SECB_COLON:	//[:_ .Ȃ] 0;00
				segDP = (msec == 0 && keta == LED2) ? SEG_DP : 0;
				break;
			case SECB_DOT:		//[:_ ._] 0:00,
				segDP = (keta == LED2 || (msec == 0 && keta == LED4)) ? SEG_DP : 0;
				break;
			default:	//SECB_STATIC:	[:_ .Ȃ] 0:00
				segDP = (keta == LED2) ? SEG_DP : 0;
				break;
			}
			idxAmPm = isPM ? SEGIDX_PM : SEGIDX_AM;
			//XCb`͔
			if (swL)
			{
				opMode = OP_ADJ_SEC;
			}
			if (swR)
			{
				orgsec = sec;
				opMode = bDispYear ? OP_CALENDAR_Y : OP_CALENDAR_MD;
			}
			break;
			
		case OP_CALENDAR_Y:
			segidx[LED1] = SEGIDX_NULL;
			if (bDispYear == 1)	//
			{
				dyear = year;
				segidx[LED2] = SEGIDX_Y;
			}
			else	//(bDispYear == 2)	
			{
				dyear = year + 12;		// =  + 12
				segidx[LED2] = SEGIDX_H;
			}
			segidx[LED3] = dyear / 10;
			segidx[LED4] = dyear % 10;
			segDP = (keta == LED4) ? SEG_DP : 0;
			//XCb`͔
			if (swL)
			{
				bDispYear = 3 - bDispYear;
				orgsec = sec;
			}
			if (swR || CALENDAR_DISP_WAIT < (sec + 60 - orgsec) % 60)
			{
				orgsec = sec;
				opMode = OP_CALENDAR_MD;
			}
			break;
			
		case OP_CALENDAR_MD:
			segidx[LED1] = (month < 10) ? SEGIDX_NULL : 1;
			segidx[LED2] = month % 10;
			segidx[LED3] = (day < 10) ? SEGIDX_NULL : day / 10;
			segidx[LED4] = day % 10;
			segDP = (keta == LED2 || keta == LED4) ? SEG_DP : 0;
			//XCb`͔
			if (swL)
			{
				bDispYear = bDispYear ? 0 : 1;
				opMode = OP_CLOCK;
			}
			if (swR || CALENDAR_DISP_WAIT < (sec + 60 - orgsec) % 60)
			{
				orgsec = sec;
				opMode = OP_CALENDAR_W;
			}
			break;
			
		case OP_ADJ_SEC:
			segidx[LED1] = SEGIDX_NULL;
			segidx[LED2] = SEGIDX_NULL;
			segidx[LED3] = sec / 10;
			segidx[LED4] = sec % 10;
			segDP = (keta == LED2) ? SEG_DP : 0;
			//XCb`͔
			if (swL)
			{
				opMode = OP_ADJ_MIN;
			}
			if (swR)
			{
				TCNT1 = 0;		//^C}JE^Zbg
				msec = sec = 0;
			}
			break;
			
		case OP_ADJ_MIN:
		case OP_ADJ_HOUR:
			segidx[LED1] = hour < 10 ? SEGIDX_NULL : 1;
			segidx[LED2] = hour % 10;
			segidx[LED3] = min / 10;
			segidx[LED4] = min % 10;
			segDP = (keta == LED2) ? SEG_DP : 0;
			idxAmPm = isPM ? SEGIDX_PM : SEGIDX_AM;
			if (opMode == OP_ADJ_HOUR)
			{
				//XCb`͔
				if (swL)
				{
					opMode = OP_ADJ_COLON;
				}
				if (swR)
				{
					hour24 = (hour24 + 1) % 24;		//Ԑ̐ݒɂ炸킹24Ԑōs
				}
				//_
				if (IS_BLINK(loopCnt))
					segidx[LED1] = segidx[LED2] = SEGIDX_NULL;
			}
			if (opMode == OP_ADJ_MIN)
			{
				//XCb`͔
				if (swL)
				{
					opMode = OP_ADJ_HOUR;
				}
				if (swR)
				{
					min = (min + 1) % 60;
				}
				//_
				if (IS_BLINK(loopCnt))
					segidx[LED3] = segidx[LED4] = SEGIDX_NULL;
			}
			break;
			
		case OP_ADJ_COLON:
			segidx[LED1] = SEGIDX_NULL;
			segidx[LED2] = 0;
			segidx[LED3] = 0;
			segidx[LED4] = 0;
			switch (secBlink)
			{
			case SECB_COLON:	//[:_ .Ȃ]
				segDP = (IS_BLINK(loopCnt) && keta == LED2) ? SEG_DP : 0;
				break;
			case SECB_DOT:		//[:_ ._]
				segDP = (keta == LED2 || (IS_BLINK(loopCnt) && keta == LED4)) ? SEG_DP : 0;
				break;
			default:	//SECB_STATIC:	[:_ .Ȃ]
				segDP = (keta == LED2) ? SEG_DP : 0;
				break;
			}
			//XCb`͔
			if (swL)
			{
				opMode = OP_ADJ_YEAR;
			}
			if (swR)
			{
				secBlink = (secBlink + 1) % 3;
			}
			break;
			
		case OP_ADJ_YEAR:
			segidx[LED1] = SEGIDX_NULL;
			segidx[LED2] = SEGIDX_Y;
			segidx[LED3] = year / 10;
			segidx[LED4] = year % 10;
			segDP = (keta == LED4) ? SEG_DP : 0;
			//XCb`͔
			if (swL)
			{
				opMode = OP_ADJ_MONTH;
			}
			if (swR)
			{
				year = (year + 1) % 100;
			}
			//_
			if (IS_BLINK(loopCnt))
				segidx[LED3] = segidx[LED4] = SEGIDX_NULL;
			break;
			
		case OP_ADJ_MONTH:
		case OP_ADJ_DAY:
			segidx[LED1] = (month < 10) ? SEGIDX_NULL : 1;
			segidx[LED2] = month % 10;
			segidx[LED3] = (day < 10) ? SEGIDX_NULL : day / 10;
			segidx[LED4] = day % 10;
			segDP = (keta == LED2 || keta == LED4) ? SEG_DP : 0;
			if (opMode == OP_ADJ_DAY)
			{
				//XCb`͔
				if (swL)
				{
					opMode = OP_ADJ_WEEK;
				}
				if (swR)
				{
					day = (day < 31) ? day + 1 : 1;		//ɂ炸31܂Őݒł
				}
				//_
				if (IS_BLINK(loopCnt))
					segidx[LED3] = segidx[LED4] = SEGIDX_NULL;
			}
			if (opMode == OP_ADJ_MONTH)
			{
				//XCb`͔
				if (swL)
				{
					opMode = OP_ADJ_DAY;
				}
				if (swR)
				{
					month = (month < 12) ? month + 1 : 1;
				}
				//_
				if (IS_BLINK(loopCnt))
					segidx[LED1] = segidx[LED2] = SEGIDX_NULL;
			}
			break;
			
		case OP_ADJ_WEEK:
		case OP_CALENDAR_W:
			segidx[LED1] = SEGIDX_NULL;
			segidx[LED2] = pgm_read_byte(&SEGIDX_WEEK[3 * week + 0]);
			segidx[LED3] = pgm_read_byte(&SEGIDX_WEEK[3 * week + 1]);
			segidx[LED4] = pgm_read_byte(&SEGIDX_WEEK[3 * week + 2]);
			segDP = (keta == LED4) ? SEG_DP : 0;
			if (opMode == OP_CALENDAR_W)
			{
				//XCb`͔
				if (swR || CALENDAR_DISP_WAIT < (sec + 60 - orgsec) % 60)
				{
					opMode = OP_CLOCK;
				}
			}
			if (opMode == OP_ADJ_WEEK)
			{
				//XCb`͔
				if (swL)
				{
					opMode = OP_CLOCK;
				}
				if (swR)
				{
					week = (week + 1) % 7;
				}
			}
			break;
			
		default:	break;
		}	//switch()
		
		//\XV
		portD = pgm_read_byte(&SEGCHAR[segidx[keta]]);
		if (keta == LED1) portD |= pgm_read_byte(&SEGCHAR[idxAmPm]);
#if	_CATHODE_CMN_
		PORTB = 0 | 0b11000000;				//DPiXCb`͂ɉeȂ悤ӂj
		PORTD = 0;
		PORTB = (segDP | (1 << keta)) | 0b11000000;
		PORTD = portD;
#else
		//Am[hR͓얢mF
		PORTB = 0b00011111 | 0b11000000;	//DPiXCb`͂ɉeȂ悤ӂj
		PORTD = 0b01111111;
		PORTB = (~(segDP | (1 << keta)) & 0b00011111) | 0b11000000;
		PORTD = ~portD & 0b01111111;
#endif
		
		//_Ci~bNhCǔw
		keta = (keta + 1) % 4;
		
	}	//while()
	
	return 0;
}
